Botan: Botan::SecureQueue Class Reference

Botan 1.10.16

Public Member Functions | Protected Member Functions | List of all members
Botan::SecureQueue Class Reference

`#include <secqueue.h>`

Inheritance diagram for Botan::SecureQueue:

## Public Member Functions
bool | attachable ()
bool | check_available (size_t n)
size_t | discard_next (size_t N)
virtual void | end_msg ()
bool | end_of_data () const
virtual std::string | id () const
std::string | name () const
SecureQueue & | operator= (const SecureQueue &other)
size_t | peek (byte[], size_t, size_t=0) const
size_t | peek_byte (byte &out) const
size_t | read (byte[], size_t)
size_t | read_byte (byte &out)
| SecureQueue ()
| SecureQueue (const SecureQueue &other)
size_t | size () const
virtual void | start_msg ()
void | write (const byte[], size_t)
| ~SecureQueue ()

## Protected Member Functions
void | attach (Filter *f)
void | incr_owns ()
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)
void | set_next (Filter *f[], size_t n)
void | set_port (size_t n)

## Detailed Description

A queue that knows how to zeroize itself

Definition at line 19 of file secqueue.h.

## Constructor & Destructor Documentation

## ◆ SecureQueue() [1/2]

Botan::SecureQueue::SecureQueue | ( |  | ) |

SecureQueue default constructor (creates empty queue)

Definition at line 60 of file secqueue.cpp.

61 {
62 set_next(0, 0);
63 head = tail = new SecureQueueNode;
64 }
Botan::Fanout_Filter::set_next
void set_next(Filter *f[], size_t n)
Definition: filter.h:144

## ◆ SecureQueue() [2/2]

Botan::SecureQueue::SecureQueue | ( | const SecureQueue & | other | ) |

SecureQueue copy constructor

Parameters

  other | the queue to copy

Definition at line 69 of file secqueue.cpp.

References Botan::Fanout_Filter::set_next(), and write().

69 :
70 Fanout_Filter(), DataSource()
71 {
72 set_next(0, 0);
73
74 head = tail = new SecureQueueNode;
75 SecureQueueNode* temp = input.head;
76 while(temp)
77 {
78 write(&temp->buffer[temp->start], temp->end - temp->start);
79 temp = temp->next;
80 }
81 }
Botan::Fanout_Filter::set_next
void set_next(Filter *f[], size_t n)
Definition: filter.h:144
Botan::Filter::Fanout_Filter
friend class Fanout_Filter
Definition: filter.h:97
Botan::SecureQueue::write
void write(const byte[], size_t)
Definition: secqueue.cpp:117
Botan::DataSource::DataSource
DataSource()
Definition: data_src.h:84

## ◆ ~SecureQueue()

Botan::SecureQueue::~SecureQueue | ( |  | ) |
| inline

Definition at line 57 of file secqueue.h.

57 { destroy(); }

## Member Function Documentation

## ◆ attach()

void Botan::Fanout_Filter::attach | ( | Filter * | f | ) |
| inlineprotectedinherited

Definition at line 146 of file filter.h.

146 { Filter::attach(f); }

## ◆ attachable()

bool Botan::SecureQueue::attachable | ( |  | ) |
| inlinevirtual

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented from Botan::Filter.

Definition at line 36 of file secqueue.h.

36 { return false; }

## ◆ check_available()

bool Botan::SecureQueue::check_available | ( | size_t | n | ) |
| inlinevirtual

Implements Botan::DataSource.

Definition at line 38 of file secqueue.h.

38 { return n <= size(); }
Botan::SecureQueue::size
size_t size() const
Definition: secqueue.cpp:190

## ◆ discard_next()

size_t Botan::DataSource::discard_next | ( | size_t | N | ) |
| inherited

Discard the next N bytes of the data

Parameters

  N | the number of bytes to discard

Returns
  number of bytes actually discarded

Definition at line 35 of file data_src.cpp.

36 {
37 size_t discarded = 0;
38 byte dummy;
39 for(size_t j = 0; j != n; ++j)
40 discarded += read_byte(dummy);
41 return discarded;
42 }
Botan::byte
unsigned char byte
Definition: types.h:22
Botan::DataSource::read_byte
size_t read_byte(byte &out)
Definition: data_src.cpp:19

## ◆ end_msg()

virtual void Botan::Filter::end_msg | ( |  | ) |
| inlinevirtualinherited

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented in Botan::MAC_Filter, Botan::Hash_Filter, Botan::PK_Verifier_Filter, Botan::Base64_Decoder, Botan::Hex_Decoder, Botan::PK_Signer_Filter, Botan::Zlib_Decompression, Botan::Bzip_Decompression, Botan::PK_Decryptor_Filter, Botan::PBE_PKCS5v20, Botan::Base64_Encoder, Botan::Hex_Encoder, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, Botan::Zlib_Compression, and Botan::PK_Encryptor_Filter.

Definition at line 44 of file filter.h.

Referenced by Botan::Filter::send().

44 {}

## ◆ end_of_data()

bool Botan::SecureQueue::end_of_data | ( |  | ) | const
| virtual

Test whether the source still has data that can be read.

Returns
  true if there is still data to read, false otherwise

Implements Botan::DataSource.

Definition at line 206 of file secqueue.cpp.

References size().

207 {
208 return (size() == 0);
209 }
Botan::SecureQueue::size
size_t size() const
Definition: secqueue.cpp:190

## ◆ id()

virtual std::string Botan::DataSource::id | ( |  | ) | const
| inlinevirtualinherited

return the id of this data source

Returns
  std::string representing the id of this data source

Reimplemented in Botan::DataSource_Stream, and Botan::DataSource_Command.

Definition at line 57 of file data_src.h.

57 { return ""; }

## ◆ incr_owns()

void Botan::Fanout_Filter::incr_owns | ( |  | ) |
| inlineprotectedinherited

Increment the number of filters past us that we own

Definition at line 140 of file filter.h.

140 { ++filter_owns; }

## ◆ name()

std::string Botan::SecureQueue::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 22 of file secqueue.h.

22 { return "Queue"; }

## ◆ operator=()

SecureQueue & Botan::SecureQueue::operator= | ( | const SecureQueue & | other | ) |

SecureQueue assignment

Parameters

  other | the queue to copy

Definition at line 101 of file secqueue.cpp.

References write().

102 {
103 destroy();
104 head = tail = new SecureQueueNode;
105 SecureQueueNode* temp = input.head;
106 while(temp)
107 {
108 write(&temp->buffer[temp->start], temp->end - temp->start);
109 temp = temp->next;
110 }
111 return (*this);
112 }
Botan::SecureQueue::write
void write(const byte[], size_t)
Definition: secqueue.cpp:117

## ◆ peek()

size_t Botan::SecureQueue::peek | ( | byte | out[],
|  | size_t | length,
|  | size_t | peek_offset = `0`
| ) |  | const
| virtual

Read from the source but do not modify the internal offset. Consecutive calls to peek() will return portions of the source starting at the same position.

Parameters

  out | the byte array to write the output to
  length | the length of the byte array out
  peek_offset | the offset into the stream to read at

Returns
  length in bytes that was actually read and put into out

Implements Botan::DataSource.

Definition at line 159 of file secqueue.cpp.

Referenced by Botan::Record_Reader::get_record(), and Botan::Output_Buffers::peek().

160 {
161 SecureQueueNode* current = head;
162
163 while(offset && current)
164 {
165 if(offset >= current->size())
166 {
167 offset -= current->size();
168 current = current->next;
169 }
170 else
171 break;
172 }
173
174 size_t got = 0;
175 while(length && current)
176 {
177 const size_t n = current->peek(output, length, offset);
178 offset = 0;
179 output += n;
180 got += n;
181 length -= n;
182 current = current->next;
183 }
184 return got;
185 }

## ◆ peek_byte()

size_t Botan::DataSource::peek_byte | ( | byte & | out | ) | const
| inherited

Peek at one byte.

Parameters

  out | an output byte

Returns
  length in bytes that was actually read and put into out

Definition at line 27 of file data_src.cpp.

References Botan::DataSource::peek().

Referenced by Botan::ASN1::maybe_BER().

28 {
29 return peek(&out, 1, 0);
30 }
Botan::DataSource::peek
virtual size_t peek(byte out[], size_t length, size_t peek_offset) const =0

## ◆ read()

size_t Botan::SecureQueue::read | ( | byte | out[],
|  | size_t | length
| ) |  |
| virtual

Read from the source. Moves the internal offset so that every call to read will return a new portion of the source.

Parameters

  out | the byte array to write the result to
  length | the length of the byte array out

Returns
  length in bytes that was actually read and put into out

Implements Botan::DataSource.

Definition at line 137 of file secqueue.cpp.

Referenced by Botan::Certificate::Certificate(), Botan::Record_Reader::get_record(), Botan::Output_Buffers::read(), Botan::TLS_Server::read(), and Botan::TLS_Client::read().

138 {
139 size_t got = 0;
140 while(length && head)
141 {
142 const size_t n = head->read(output, length);
143 output += n;
144 got += n;
145 length -= n;
146 if(head->size() == 0)
147 {
148 SecureQueueNode* holder = head->next;
149 delete head;
150 head = holder;
151 }
152 }
153 return got;
154 }

## ◆ read_byte()

size_t Botan::DataSource::read_byte | ( | byte & | out | ) |
| inherited

Read one byte.

Parameters

  out | the byte to read to

Returns
  length in bytes that was actually read and put into out

Definition at line 19 of file data_src.cpp.

References Botan::DataSource::read().

Referenced by Botan::PEM_Code::decode(), and Botan::PGP_decode().

20 {
21 return read(&out, 1);
22 }
Botan::DataSource::read
virtual size_t read(byte out[], size_t length)=0

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Hex_Encoder::Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), Botan::CBC_Decryption::set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ set_next()

void Botan::Fanout_Filter::set_next | ( | Filter * | f[],
|  | size_t | n
| ) |  |
| inlineprotectedinherited

Definition at line 144 of file filter.h.

Referenced by SecureQueue().

144 { Filter::set_next(f, n); }

## ◆ set_port()

void Botan::Fanout_Filter::set_port | ( | size_t | n | ) |
| inlineprotectedinherited

Definition at line 142 of file filter.h.

142 { Filter::set_port(n); }

## ◆ size()

size_t Botan::SecureQueue::size | ( |  | ) | const

Returns
  number of bytes available in the queue

Definition at line 190 of file secqueue.cpp.

Referenced by Botan::Certificate::Certificate(), end_of_data(), Botan::Record_Reader::get_record(), Botan::TLS_Server::read(), Botan::TLS_Client::read(), and Botan::Output_Buffers::remaining().

191 {
192 SecureQueueNode* current = head;
193 size_t count = 0;
194
195 while(current)
196 {
197 count += current->size();
198 current = current->next;
199 }
200 return count;
201 }

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

## ◆ write()

void Botan::SecureQueue::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 117 of file secqueue.cpp.

Referenced by Botan::Record_Reader::add_input(), Botan::Certificate::Certificate(), Botan::TLS_Server::close(), Botan::TLS_Client::is_closed(), operator=(), and SecureQueue().

118 {
119 if(!head)
120 head = tail = new SecureQueueNode;
121 while(length)
122 {
123 const size_t n = tail->write(input, length);
124 input += n;
125 length -= n;
126 if(length)
127 {
128 tail->next = new SecureQueueNode;
129 tail = tail->next;
130 }
131 }
132 }

The documentation for this class was generated from the following files:

- src/filters/secqueue.h
- src/filters/secqueue.cpp